/*!
 * Copyright (c) 2015-2018, NADAL Jean-Baptiste. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA
 *
 * @Author:  NADAL Jean-Baptiste
 * @Date: 04/05/2017
 */

#ifndef _UBUS_EXEC_RECEIVER_H
#define _UBUS_EXEC_RECEIVER_H

/*------------------------------- INCLUDES ----------------------------------*/

#include <string>

extern "C" {
#include <libubus.h>
#include <libubox/blobmsg_json.h>
}

/*--------------------------------- CLASS ----------------------------------*/

class UBusExecReceiver : public ubus_request
{
  public:
	UBusExecReceiver(void);
	virtual ~UBusExecReceiver(void);

	int abort(struct ubus_context *a_ctx);
	int complete_request_async(struct ubus_context *a_ctx);

	void add_data(std::string a_data);
	const std::string &get_data(void);

	void add_result(int a_result);
	int get_result(void);

	virtual void complete(void) = 0;

  private:
	std::string m_data;
	int m_result;
};

#endif /* _UBUS_EXEC_RECEIVER_H */
